<?php
// Set flag that this is a parent file
// Necesario para poder llamara este script directamente y
// poder incluir otros ficheros.
define( '_VALID_MOS', 1 );
define( '_JEXEC', 1 );
/**
*
* @version $Id: vm4b_notify.php,v 1.4 2008/02/28 11:20:23 celano Exp $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*
*Original Code By Jos Celano (josecelano)
*Modified/Improved by Yos Okusanya
*Email: yosolu@sankuru.biz
*License: GPL - General Public License
*
*/

/**
* This code receives s4B transaction details and updates the vm tables accordingly
* 
*/

/*
 * TO-DO: 
 * - MAC HASH para mayor seguridad.
 */
 
/*
 *
 * Este script es llamado por el sistema 4B cuando finaliza una transaccin
 * para que en la aplicacin del comercio se hagan los cambios oportunos.
 * 
 * Recibe una peticin y se encarga de actualizar el estado del pedido en
 * la base de datos segn haya sido el resultado de la operacin.
 * 
 * Si la transaccin ha sido autorizada cambia el estado del pedido a
 * confirmado.
 * Si la transaccin ha sido cancelado o fallida entonces enva un correo
 * al administrador indicando que un cliente a intentado hacer un pago y
 * ha tenido un error, adems inserta un registro en el histrico de estados
 * de un pedido con los datos de la transaccin.
 * 
 * En ambos casos envia un correo al administracin con el resultado de la
 * operacin. 
 *  
 */
 //die('called');
// Fichero de configuracin de joomla
//require_once '../../../../../configuration.php';
include('../../../configuration.php');
include('classes/payment/ps_4b.cfg.php');
 
//=============================
include('classes/payment/ps_vm4b_log.php');

$log_file = new ps_vm4b_log();

$config_params = new JConfig();

$dbprefix = $config_params->dbprefix;

//===========================
 

// Comprueba que el origen de la peticin sea el servidor 4B
$remoteIP = $_SERVER['REMOTE_ADDR'];
if (strstr($remoteIP, ', ')) {
   $ips = explode(', ', $remoteIP);
   $remoteIP = $ips[0];
}

//============check IP address=========================
if ($remoteIP != S4B_SERVER_IP) 
{
	$log_file->logError(S4B_INVALID_IP_ERROR.$remoteIP.S4B_TRANS_TERMINATED);
    die();
}
//=================================================


// PARMETROS ENVIADOS POR 4B
$result = $_REQUEST['result'];                      // Resultado de la transaccin: 0->Transaccin autorizada, 1->Transaccin cancelada, 2->Transaccin fallida
$pszPurchorderNum = $_REQUEST['pszPurchorderNum'];  // Referencia de la compra
$pszTxnDate = $_REQUEST['pszTxnDate'];              // Fecha de la transaccin: dd/mm/aa
$tipotrans = $_REQUEST['tipotrans'];                // Tipo de transaccin: SSL/CES
$store = $_REQUEST['store'];                        // Nombre abreviado tienda: (clave, dato aportado por 4B)

// Si la operacin se efectua correctamente
$pszApprovalCode = $_REQUEST['pszApprovalCode'];    // Cdigo de autorizacin
$pszTxnID = $_REQUEST['pszTxnID'];                  // Id. de transaccin

// Si la operacin resulta fallida:
$coderror = $_REQUEST['coderror'];                  // Cdigo de error
$deserror = $_REQUEST['deserror'];                  // Descripcin de error

// Firma de datos (opcional, debe activarse en Mdulo de Configuracin):
$MAC = $_REQUEST['MAC'];                            // Firma RSA de los parmetros: Resumen hash de los parmetros enviados.    

// FIN PARMETROS ENVIADOS POR 4B

// Solo por cambio de nomenclatura de 4B a virtuemart
$order_id = $pszPurchorderNum;   

if($result == 0)
{
	$status = 'confirmed';
}
elseif($result == 1)
{
	$status = 'cancelled';
}
else
{
	$status = 'failed';
}

	if(S4B_EXT_LOG)
	{
		$log_file->logExtensive(S4B_DETAIL_COMP." Order ID: $order_id, Purchase Number: $pszPurchorderNum Status: $status, 
					Purchase date: $pszTxnDate, Aprroval code: $pszApprovalCode, Transaction ID: $pszTxnID
					");
	}

	if($coderror)
	{
		$log_file->logError("Order ID: $order_id, Purchase Number: $pszPurchorderNumOrder, Status: $status, 
					Purchase date: $pszTxnDate, Aprroval code: $pszApprovalCode, Transaction ID: $pszTxnID, Error Code: $coderror, Error Description: $deserror
					");
	}

// Comprueba que se haya especificado un nmero de pedido
if( !isset($order_id) || empty($order_id)) {
	$log_file->logError(S4B_NO_ORDER_ID);
	die();
}
else {
    
    // Conexion, seleccion de base de datos
    $link = mysql_connect($config_params->host, $config_params->user, $config_params->password)
       or $log_file->logError(S4B_DBASE_CON_ERROR.mysql_error());
    
    mysql_select_db($config_params->db) 
        or $log_file->logError(S4B_DBASE_CON_ERROR.mysql_error());

//=============format date for database ===========================
	$db_date = explode('/', $pszTxnDate);
	$temp = $db_date[0];
	$db_date[0] = $db_date[1];
	$db_date[1] = $temp;
	$db_format = implode("/", $db_date);
//=======================================	
	
	if($pszTxnID)
	{
		$log_query = "INSERT INTO ".$dbprefix."vm_orders_4b (orderid, result, transid, date, transtype, authcode, errorcode, deserror)
				VALUES($order_id, $result, $pszTxnID, '".date('Y-m-d', strtotime($db_format))."', '$tipotrans', '$pszApprovalCode', '$coderror', '$deserror')";
	}
	else
	{
		$log_query = "INSERT INTO ".$dbprefix."vm_orders_4b (orderid, result, date, transtype, authcode, errorcode, deserror)
			VALUES($order_id, $result, '".date('Y-m-d', strtotime($db_format))."', '$tipotrans', '$pszApprovalCode', '$coderror', '$deserror')";
	}
	
	$ret = mysql_query($log_query) 
            or $log_file->logError(S4B_DBASE_ERROR."order id: $order_id, table:vm_orders_4b, detail: ".mysql_error());

			     
    // Segn resultado de la operacin ...
    switch ($result) {
    case 0:
        // TRANSACCIN AUTORIZADA
        echo "Transaccin autorizada<br/>";
        
        // Cambia el estado del pedido a confirmado
        
        $q = "UPDATE `".$dbprefix."vm_orders` SET ";
        $q .= "`order_status` = '".S4B_VERIFIED_STATUS."'";
        $q .= " WHERE `order_id`=$order_id LIMIT 1;";
        
 
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR."order id: $orderi_d, update table:vm_orders, status:confirmed, details : ".mysql_error());
		
		$q = "UPDATE `".$dbprefix."vm_order_item` SET ";
        $q .= "`order_status` = '".S4B_VERIFIED_STATUS."'";
        $q .= " WHERE `order_id`=$order_id;";
        
 
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR."order id: $orderi_d, update table:vm_order_item, status:confirmed, details : ".mysql_error());
	
      
        // Obtiene el instante actual formateado para MySQL
        $now_MySQL = date('Y-m-j h:i:s');
        
        // Comentarios
        $comments = "Resultado de la transaccin: $result<br/>\n";
        $comments .= "Referencia de la compra: $pszPurchorderNum<br/>\n";
        $comments .= "Fecha de la transaccin: $pszTxnDate<br/>\n";
        $comments .= "Tipo de transaccin: $tipotrans<br/>\n";
        $comments .= "Nombre abreviado tienda: $store<br/>\n";
        $comments .= "Cdigo de autorizacin: $pszApprovalCode<br/>\n";
        $comments .= "Id. de transaccin: $pszTxnID<br/>\n";
        $comments .= "Cdigo de error: $coderror<br/>\n";
        $comments .= "Descripcin de error: $deserror<br/>\n";
 	
		$q = "INSERT INTO `".$dbprefix."vm_order_history` ( `order_status_history_id` , `order_id` , `order_status_code` , `date_added` , `customer_notified` , `comments` )";
        $q .= "VALUES (";
        $q .= "NULL , '".$order_id."', '".S4B_VERIFIED_STATUS."', '".$now_MySQL."', '0', '".$comments."'";
        $q .= ");";
        
        
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR."$order_id  vm_order_history table : ". mysql_error());

             
        $q = "SELECT *";
        $q .= "FROM `".$dbprefix."vm_vendor`";
        $q .= "WHERE `vendor_id` =".S4B_VENDOR_ID."";
         
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR.", vendor id: ".S4B_VENDOR_ID.", table: vm_vendor, detail: ". mysql_error());

        
        // Cerrar la conexion
        mysql_close($link); 

        break;
    case 1:
    case 2:
        // TRANSACCIN CANCELADA
        // TRANSACCIN FALLIDA
        
        
        // Aade al historial de estados del pedido un nuevo registro
        // indicando la incidencia.
        
        // Obtiene el instante actual formateado para MySQL
        $now_MySQL = date('Y-m-j h:i:s');
		
		// Cambia el estado del pedido a cancelada
        
        $q = "UPDATE `".$dbprefix."vm_orders` SET ";
        $q .= "`order_status` = '".S4B_CANCELLED_STATUS."'";
        $q .= " WHERE `order_id`=$order_id LIMIT 1;";
        
 
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR."order id: $orderi_d, update table:vm_orders, status:canceled, details : ".mysql_error());
	
        
		$q = "UPDATE `".$dbprefix."vm_order_item` SET ";
        $q .= "`order_status` = '".S4B_CANCELLED_STATUS."'";
        $q .= " WHERE `order_id`=$order_id;";
        
 
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR."order id: $orderi_d, update table:vm_order_item, status:canceled, details : ".mysql_error());
	
       
        // Comentarios       
        $comments = "Resultado de la transaccin: $result<br/>\n";
        $comments .= "Referencia de la compra: $pszPurchorderNum<br/>\n";
        $comments .= "Fecha de la transaccin: $pszTxnDate<br/>\n";
        $comments .= "Tipo de transaccin: $tipotrans<br/>\n";
        $comments .= "Nombre abreviado tienda: $store<br/>\n";
        $comments .= "Cdigo de autorizacin: $pszApprovalCode<br/>\n";
        $comments .= "Id. de transaccin: $pszTxnID<br/>\n";
        $comments .= "Cdigo de error: $coderror<br/>\n";
        $comments .= "Descripcin de error: $deserror<br/>\n";
        
         $q = "INSERT INTO `".$dbprefix."vm_order_history` ( `order_status_history_id` , `order_id` , `order_status_code` , `date_added` , `customer_notified` , `comments` )";
        $q .= "VALUES (";
        $q .= "NULL , '".$order_id."', '".S4B_CANCELLED_STATUS."', '".$now_MySQL."', '0', '".$comments."'";
        $q .= ");";
        
         
        // Comentado para depuracin
        $ret = mysql_query($q) 
            or $log_file->logError(S4B_DBASE_ERROR." order id: $order_id, table: vm_order_history, detail ". mysql_error());
			        
        
        // Liberar conjunto de resultados
        mysql_free_result($ret);
        
        // Cerrar la conexion
        mysql_close($link); 
        
        break;
    }        
    
}

?>