<?php
// Set flag that this is a parent file
// Necesario para poder llamara este script directamente y
// poder incluir otros ficheros.
define( '_VALID_MOS', 1 );
define( '_JEXEC', 1 );
/**
*
* @vm4b_requestdetails
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*
*Original Code by Jos Celano (josecelano)
*Modified/Improved by Yos Okusanya
*Email: yosolu@sankuru.biz
*License: GPL - General Public License
*
*/

/**
* This code sends the cart information to 4b
* 
*/

/*
 * TO-DO: 
 * - MAC HASH para mayor seguridad.
 * - Comprobar que hay que poner en moneda en cada registro, si el precio por 
 *   artculo o el total de precio por la cantidad? Est puesto lo primero.
 */

/*
 *
 * Este script recibe la peticin de informacin de la cesta de la compra
 * del servidor de pagos del Sistema  4B.
 * 
 * Recibe la peticin, obtiene los parmetros y genera un fichero de texto
 * con los datos de la cesta del pedido indicado como parmetro. 
 * 
 * Variables devueltas mediante GET por el Sistema  4B 
 * al solicitar los datos de la cesta de la compra:
 * 
 * order
 * referencia de la compra
 *   
 * store
 *   nombre abreviado (clave) de la tienda virtual
 *     
 * En respuesta el mdyulo de pago deber generar una salida que debe incluir:
 * 1.- Importe total de la compra: en euros. 
 * Formato: MXXXNNN Donde XXX es el cdigo de moneda ISO (978 para el euro), 
 * y NNN la cifra del importe. No debe incluir separadores de miles ni comas 
 * decimales. El importe en euros debe darse multiplicado por cien, ya que los 
 * dos ltimos dgitos de la derecha se interpretarn como decimales 
 * (cntimos de euro). 
 * 
 * Por ejemplo: 34,51 Euros -> M9783451. 
 * 
 * Si en vez de una operacin de venta se quiere solicitar una operacin de 
 * preautorizacin se antepondr el prefijo PRE a la cadena de importe 
 * especificada. 
 * 
 * Ejemplo de preautorizacin 40 Euros -> PREM9784000.
 * 
 * 2.- Nmero de registros (tems) de la cesta de la compra: un nmero que indica 
 * cuantos productos forman la cesta de la compra y vienen descritos a continuacin.
 * 
 * 3.- Registros de la cesta de la compra: cada registro debe contener los 
 * siguientes campos:
 *  
 * -   Referencia
 * -   Descripcin
 * -   Unidades
 * -   Precio: utilizando el mismo formato que en el importe total de la 
 *     compra, pero omitiendo el cdigo de moneda.
 *     
 * Estos cuatro ltimos campos deben repetirse tantas veces como registros haya 
 * en la cesta de la compra, si bien el detalle de descripcin de estos registros 
 * est libremente determinado por el comercio.
 * Cada dato debe ir en una lnea diferente, es decir terminado con el carcter 
 * de retorno de carro, sin lneas en blanco ni cdigo HTML. 
 * 
 * Ejemplo 1: Suponemos que el Pasat Internet ha recibido la peticin del 
 * comercio X de la compra de referencia Z, con lo cual realiza una llamada al 
 * servidor de comercio para que devuelva el desglose de la compra Z: 
 * Compra de un libro Novelas clsicas Vol.1 con referencia A1345, 
 * de 5 Euros y una cinta VHS- El fin de los das con referencia A1348, 
 * de 7 Euros. Importe total de la compra 12 Euros.
 *  
 * El programa del comercio debera responder:
 * 
 * M9781200
 * 2
 * A1345
 * Novelas clsicas Vol.1
 * 1
 * 500
 * A1348
 * VHS  El fin de los dias
 * 1
 * 700
 * 
 */
 
// Buffer de salida para no enviar caracteres no deseados
ob_start();
 
include_once 'classes/payment/ps_4b.cfg.php';
include_once 'classes/payment/ps_vm4b_log.php';

$log_file = new ps_vm4b_log();


// Comprueba que el origen de la peticin sea el servidor 4B
$remoteIP = $_SERVER['REMOTE_ADDR'];
if (strstr($remoteIP, ', ')) {
   $ips = explode(', ', $remoteIP);
   $remoteIP = $ips[0];
}
//============check IP address=========================
if ($remoteIP != S4B_SERVER_IP) 
{
	$log_file->logError(S4B_INVALID_IP_ERROR.$remoteIP.S4B_TRANS_TERMINATED);
     
   // No existe el pedido -> Devuelve carro vacio
	$basket4B = "";
	$basket4B .= "M978000\n";
	$basket4B .= "0\n";
			
}
//=================================================
else
{
	// Parmetros enviados por Pasat Internet 4B
	$order = $_REQUEST['order'];    // Id o referencia de la compra
	$store = $_REQUEST['store'];    // Nombre abreviado (clave) de la tienda virtual   

	if( !isset( $_REQUEST["order"] ) || empty( $_REQUEST["order"] )) {
	    $log_file->logError(S4B_NO_ORDER_ID);
	}
	else 
	{
	    
	    include_once("classes/payment/ps_4b.cfg.php");
		
	    		
		include_once '../../../configuration.php';
	    
		$config_params = new JConfig();
		
		$dbprefix = $config_params->dbprefix;
		
		if(S4B_EXT_LOG)
		{
			$log_file->logExtensive("Order id: $order ".S4B_DETAIL_REQ);
			
		}
	    // El carro tiene varios items -> Devuelve el carro en el formato 4B
	    $basket4B = "";
	   
	    // Conexion, seleccion de base de datos
	    $link = mysql_connect($config_params->host, $config_params->user, $config_params->password)
	        or $log_file->logError(S4B_DBASE_CON_ERROR.mysql_error());
	    
	    mysql_select_db($config_params->db) 
	       or $log_file->logError(S4B_DBASE_CON_ERROR.mysql_error());

	    // Obtiene los datos del pedido
	    $q = "SELECT * FROM `".$dbprefix."vm_orders` WHERE ";
		$q .= $dbprefix."vm_orders.order_id= $order";
	        
	    	        
	    $result = mysql_query($q) 
	        or $log_file->logError(S4B_DBASE_ERROR."order id: $order table: vm_orders details: ".mysql_error());
	    	
	    // Comprueba que exista el pedido
	    if (mysql_num_rows($result) == 0) {

	        // No existe el pedido -> Devuelve carro vacio
	        $basket4B = "";
	        $basket4B .= "M978000\n";
	        $basket4B .= "0\n";
			
	        
	    } 
		else 
		{
	        
	        // Datos del pedido
	        $order_record = mysql_fetch_array($result, MYSQL_ASSOC);
		
			$currency_code = $order_record["order_currency"];
			
			$q = "SELECT * FROM `".$dbprefix."4b_currencies` WHERE ";
			$q .= "".$dbprefix."4b_currencies.curr_3_code = '$currency_code'";

	              
		    $result = mysql_query($q) 
		        or $log_file->logError(S4B_DBASE_ERROR."currency code: $currency_code table: 4b_currencies  details: ".mysql_error());
			
			$s4b_record = mysql_fetch_array($result, MYSQL_ASSOC);
			$s4b_code = $s4b_record["s4b_curr_code"];
			
			if(!$s4b_code)
			{
				$log_file->logError(S4B_NO_CURR_CODE);
				
		        // No existe el pedido -> Devuelve carro vacio
		        $basket4B = "";
		        $basket4B .= "M978000\n";
		        $basket4B .= "0\n";			
		        
		    }
			else 
			{
			
		                
		        $shipping_total = $order_record["order_shipping"];
		        $order_total = $order_record["order_total"];
		        
		        // Totales del pedido en formato moneda 4B
		        $shipping_4Bformat_total = number_format($shipping_total, 2, "", "");
		        $order_4Bformat_total = number_format($order_total, 2, "", "");
				
			
				
				$order_4Bformat_total = $s4b_code.$order_4Bformat_total;
				
				
				 // Total del pedido
				$basket4B .= "M$order_4Bformat_total\n";
			
		        
		       				
		        // Liberar conjunto de resultados
		        mysql_free_result($result);
		    
			
		        // Obtiene los productos del pedido
		        $q  = "SELECT * FROM `".$dbprefix."vm_order_item` ";
		        $q .= "WHERE ".$dbprefix."vm_order_item.order_id='$order' ";
		            
		        $result = mysql_query($q) 
		            or $log_file->logError(S4B_DBASE_ERROR."order id: $order table: vm_order_items details: ". mysql_error());
				
		                        
		        $items_num = mysql_num_rows($result);
		                                
		        // Nmero de registros del pedido (ms 1 registro de gastos de envo)
		        $basket4B .= $items_num + 1 . "\n";

		        while ($item_record = mysql_fetch_array($result, MYSQL_ASSOC)) {

		            // Referencia
		            $basket4B .= $item_record["order_item_sku"] . "\n";
		            // Nombre del producto
		            $basket4B .= $item_record["order_item_name"] . "\n";
		            // Cantidad
		            $basket4B .= $item_record["product_quantity"] . "\n";
		            // Precio
		            // TO-DO: Comprobar que se pone si el precio por artculo o el
		            // total de precio por la cantidad?
		            $basket4B .= number_format($item_record["product_final_price"], 2, "", "") . "\n";
		        }
		            
		        // Aade un registro de gastos de envo
		        // Referencia
		        $basket4B .= "REF-0\n";
		        // Nombre del producto
		        $basket4B .= "Gastos de envo" . "\n";  // TO-DO: coger del fichero de configuracin.
		        // Cantidad
		        $basket4B .= 1 . "\n";
		        // Precio
		        $basket4B .= $shipping_4Bformat_total . "\n";
			}	
	           
	    }
	    
	    // Liberar conjunto de resultados
	    mysql_free_result($result);
	    
	    // Cerrar la conexion
	    mysql_close($link);    
	    
	    // Vaciar el buffer de salida para evitar mandar basura.
	    // Solo queremos enviar los datos de la cesta
	    ob_end_clean();
	    
		if(S4B_EXT_LOG)
		{
			$log_file->logExtensive("Order id: $order ".S4B_DETAIL_SENT);
		}
		
	    // Enva la cesta al Sistema 4B
	    //header('Content-Transfer-Encoding: text');
	    header('Content-Type: text/plain');
	    header('Content-Encoding: none');
	    echo $basket4B;
	}
}

?>